angular.module('beamng.apps')

.constant('SURFACES', {

	surface: [
		{ txt: 'Asphalt',      		val: 'ASPHALT'     		},
		{ txt: 'Asphalt Old',  		val: 'ASPHALT_OLD' 		},
		{ txt: 'Asphalt Prepped',  	val: 'ASPHALT_PREPPED' 	},
		{ txt: 'Asphalt Wet',   	val: 'ASPHALT_WET'		},
		{ txt: 'Cobblestone',  		val: 'COBBLESTONE'   	},
		{ txt: 'Dirt',         		val: 'DIRT'           	},
		{ txt: 'Dirt Dusty',      	val: 'DIRT_DUSTY' 		},
		{ txt: 'Dirt Dusty Loose',  val: 'DIRT_DUSTY_LOOSE'	},
		{ txt: 'Grass',       		val: 'GRASS' 			},
		{ txt: 'Gravel',      		val: 'GRAVEL'     		},
		{ txt: 'Ice',  				val: 'ICE' 				},
		{ txt: 'Metal',         	val: 'METAL'        	},
		{ txt: 'Metal Tread',      	val: 'METAL_TREAD'     	},
		{ txt: 'Mud',  				val: 'MUD' 				},
		{ txt: 'Plastic',         	val: 'PLASTIC'        	},
		{ txt: 'Rock',      		val: 'ROCK'     		},
		{ txt: 'Rumble Strip',  	val: 'RUMBLE_STRIP'		},
		{ txt: 'Sand',         		val: 'SAND'        		},
		{ txt: 'Slippery',      	val: 'SLIPPERY'     	},
		{ txt: 'Snow',  			val: 'SNOW' 			},
		{ txt: 'Wood',         		val: 'WOOD'        		},
	],
})

.directive('changeGroundGripAngelo234', ['SURFACES', 'bngApi', function (SURFACES, bngApi) {
return {
templateUrl: 'modules/apps/change_ground_grip_angelo234/app.html',
replace: true,
restrict: 'EA',
link: function (scope, element, attrs) {
	
	// The current overlay screen the user is on (default: null)
	scope.overlayScreen = null;

	scope.staticFrictionCoefficient = 0;
	scope.slidingFrictionCoefficient = 0;
	
	bngApi.engineLua('change_ground_grip_angelo234_getCurrentSurfaceUIValue()', function(data) {	
		//when resetting UI but not map, use value from Lua
		if(data != null){
			scope.surface_options = {value: data, options: SURFACES.surface};	
		}
		else{
			scope.surface_options = {value: 'ASPHALT', options: SURFACES.surface};
		}	
	});	

	//FUNCTIONS
	
	function init(){
		//Store default data in memory and update values 
		
		bngApi.engineLua('change_ground_grip_angelo234_init()', function(data) {
			updateUIValues();
		});	
	}
	
	function setSurfaceParameter(param){
		var surface = scope.surface_options.value
		var value;	
		eval("value = scope." + param)
		
		bngApi.engineLua('change_ground_grip_angelo234_setSurfaceParameter("' + surface + '","' + param +'",' + value + ')');
	}

	function updateUIValue(param){
		var surface = scope.surface_options.value
		
		bngApi.engineLua('change_ground_grip_angelo234_getSurfaceParameter("' + surface + '","' + param +'")', function(data) {
			var value = Math.round((data + Number.EPSILON) * 100) / 100;

			eval("scope." + param + " = value");
		});		
	}
	
	function updateUIValues(){
		//Set values to match current surface
		
		updateUIValue("staticFrictionCoefficient");
		updateUIValue("slidingFrictionCoefficient");
	}

	//When selecting a different surface in UI
	scope.changeSurface = function () {
        updateUIValues();
		
		var curr_surface = scope.surface_options.value;
		
		bngApi.engineLua('change_ground_grip_angelo234_setCurrentSurfaceUIValue("' + curr_surface + '")');
    };

	scope.changeGrip = function () {
		//Set values
		setSurfaceParameter("staticFrictionCoefficient");
		setSurfaceParameter("slidingFrictionCoefficient");
		
		var surface = scope.surface_options.value
		
		//Apply changes
		bngApi.engineLua('change_ground_grip_angelo234_applyChanges("' + surface + '")');
    };

	scope.resetCurrentSurfaceGrip = function () {
		var surface = scope.surface_options.value
		
        bngApi.engineLua('change_ground_grip_angelo234_resetSurface("' + surface + '")');
		
		updateUIValues();
    };

	scope.resetAllGrip = function () {		
		bngApi.engineLua('change_ground_grip_angelo234_resetAllSurfaces()');
		
		updateUIValues();
    };


	//START

	init();


	// An optional list of streams that will be used in the app
	//var streamsList = [/* streams here */];

	// Make the needed streams available.
	//StreamsManager.add(streamsList);

	// Make sure we clean up after closing the app.
	scope.$on('$destroy', function () {
		//StreamsManager.remove(streamsList);
	});

	scope.$on('streamsUpdate', function (event, streams) {
	/* Some code that uses the streams' values */
	});
},
};
}]);